//This some documentation for AVRDUDE http://www.nongnu.org/avrdude/user-manual/avrdude.html
//else simplest thing you can do is turn on verbose output during upload and watch for a command in the end with AVRDUDE in it along with the path of hex file, just copy paste & run the same command in CommandLine; your task is accomplished.
//https://www.nongnu.org/avrdude/user-manual/avrdude_6.html

/*
   Zum Kalibrieren des Sparks muss nur das "#define UDETECT00" mit // auskommentiert werden, geflasht werden und
   anschließend im UNBELASTETEN (keine Lok auf Gleis) Zustand (nur DCC1 und DCC2 angeschlossen) der Wert am Display abgelesen und im Display
   der Wert abgelesen und hinter "#define UDETECT00" eingetragen werden.
   Für mehr als einen Abschnitt (BLOCKANZ>1) wird ein Array ermittelt, welches in den Code eingefügt werden muss.
*/
// 2019-09-24 in wiring.c #define ENABLE_IE deaktivieren !!!, DCC-IN über Optokoppler 6N136/6N137 nicht erforderlich, es reicht 10k gen GND
// ggf. 1k an D13 LED entfernen oder anderen Pin verwenden (#define  TX_PIN)
// Arduino IDE 1.8.5, Arduiono AVR Boards by Arduino Version 1.6.20

// anzupassende Konstanten:
#define I2CADDR 60      // Adresse des OLED-Displays (LCD-Standard 0x27, 0x3F; OLED 60)

#define FIRSTBLOCKADDR 16    // Adresse des ersten Rückmelders (an Pin A0) mit 1 beginnend, für Test = 7 ODER 17

#if defined(__AVR_ATmega328P__)  // vordefiniert für NANO

#define OLEDDISPLAY
//  #define LCD

//#define EINZEILIG             // Ausgabe nur einer Loknummer am OLED-Display
//#define LCDANZPIN 2           // <256: Adresse per LCD anzuzeigenden Rückmeldeabschnitts mit 0 beginnend; >255: bitcodiert die auszuwertenden Kanäle, z. B. 0x1FF für alle, 0x104 für 2 (ab V39, nur OLED MEHRZEILIG)
#define LCDANZPIN 0x1FF         // <256: Adresse per LCD anzuzeigenden Rückmeldeabschnitts mit 0 beginnend; >255: bitcodiert die auszuwertenden Kanäle, z. B. 0x1FF für alle, 0x104 für 2 (ab V39, nur OLED MEHRZEILIG)

// nur für mehrzeilig  //  #undef EINZEILIG
#define I2CTYPELCD16x2 2 
#define I2CTYPELCD16x4 4 
#define I2CTYPEOLED128x32 32 
#define I2CTYPEOLED128x64 64

#define TCAADDR 0x70
#define NRSTELLEN 5             // max. Stellenanzahl der Loknummer (1..5), nur bei mehreren in einer Zeile
//#define SHOWCHAN  0           // zeige Kanalnummer vor Loknummer, Wert gibt einen Offset der zur Kanalnummer hinzugefügt wird an
#define CLEARINITSCREEN 2       // lösche Init-Information nach 2 Sekunden, ausbeblendet bleibt Init-Info bis zur ersten RC-Info

byte chanDispAddr[]      = {  61,  61,  61,  60,  60,  60,   0,   0};  // I2C-adresse des Displays, 0 = kein Display
byte chanDispMultiplex[] = {   7,   7,   7,   7,   0,   2,   6,   7};
byte chanDispTyp[]       = { 164,  64,  64, 132,  64,  64,   1,   1};  // 32 = I2CTYPEOLED128x32, 64 = I2CTYPEOLED128x64, +100 = um 180° gedreht, (2 = I2CTYPELCD16x2, 4 = I2CTYPELCD16x4)* LCD in Vorbereitung, vielleicht 
byte chanDispUmbruch[]   = {   0,   0,   2,   0,   1,   0,   1,   1};  // 1 = Zeilenumbruch nach erster, 2 = nach zweiter, 3 = nach dritter, 123 = nach 1. und 2., 123 = nach 1.+ 2.+ 3. Nummer
byte chanDispSetX[]      = {   1,   1,   1,   3,   2,   3,   1,   1};  // 1 = normale (7 pix hoch), 2 = zweifache (14/16 pix), 3 = dreifache (32 pix) Zeichenhoehe
byte chanDispYPos[]      = {   0,   2,   4,   0,   0,   0,  12,  14};  // bei SetX = 2 sollte min. der doppelte Zeilenabstand gesetzt werden (1 = 8 pix)



//#define INVERTBLOCKADDR   // Block-Adressen rückwärtslaufend, FIRSTBLOCKADDR ist dann die höchste Blockadresse (an Pin A0)
//#define RCONLYPRESENT2LN  // sende MultiSenseLong nur bei RC-Belegt (present=1), unterdrücke present=0

//#define UDETECT00 275  // NANO-Nullabgleich: zum Testen auskommentieren, Wert aus Serial-Monitor ablesen und hier eintragen

//Parameter für die einzelnen Karten
#if FIRSTBLOCKADDR == 17
//UH_8er_raster
//  #define UDETECT00 275  // NANO-Nullabgleich: zum Testen auskommentieren, Wert aus Serial-Monitor ablesen und hier eintragen
  int ux0[8] = {275, 275, 275, 275, 275, 275, 305, 305};  // Zeile aus Serial-Monitor ablesen und hier eintragen

#elif FIRSTBLOCKADDR == 8  //höchste Adresse (an Pin A0)
//AS_8er_klein_1
  #define INVERTBLOCKADDR
  #define RCONLYPRESENT2LN
  #define UDETECT00 293  // NANO-Nullabgleich: zum Testen auskommentieren, Wert aus Serial-Monitor ablesen und hier eintragen
  int ux0[8] = {293, 294, 293, 291, 292, 292, 440, 439};
#elif FIRSTBLOCKADDR == 16 //höchste Adresse (an Pin A0)
//AS_8er_klein_2
  #define INVERTBLOCKADDR
  #define RCONLYPRESENT2LN
  #define UDETECT00 292  // NANO-Nullabgleich: zum Testen auskommentieren, Wert aus Serial-Monitor ablesen und hier eintragen
  int ux0[8] = {292, 292, 292, 292, 291, 291, 431, 431};

#else
//UH_8er_raster
//  #define UDETECT00 275  // NANO-Nullabgleich: zum Testen auskommentieren, Wert aus Serial-Monitor ablesen und hier eintragen
  int ux0[8] = {275, 275, 275, 275, 275, 275, 305, 305};  // Zeile aus Serial-Monitor ablesen und hier eintragen
#endif
  int noschottky[8] = {0, 0, 0, 0, 0, 0, 0, 0};           // Pin 5 und 7 testweise mit N4001 --> 30 .. 50 eintragen


#define ANALOGREADPIN 0   // NANO, Angabe des (ersten) Analog-Ports, Nummer 0..7, NICHT A0..A7 !!!

#define DETECT8KANAL          // Detektor mit bis zu 8 Werten
#define LOCONET             // Ausgabe im Loconet, optimiert für Rocrail
#define BLOCKANZ 8          // Anzahl Rückmelder (1 .. 8)

#define RCONDELAY             // Eintrag erst bei 2. Erscheinen, Versuch Phantome zu verhindern

//#define REMOVEDELAYMS 50    // minimale Ausschaltverzögerung in ms
//#define REMOVEDELAYMS 500   // Ausschaltverzögerung in ms, für ca. 25 Loks OK
//#define REMOVEDELAYMS 2000  // Ausschaltverzögerung in ms, für 60...100 Loks OK
#define REMOVEDELAYMS 1000
#define REMOVEONLYWITHADDR 2  //1..3.. geht erst wenn Adresse x-mal ohne RC-Quitt aufgerufen, bei Roco z21(Start) ist höher besser, da DCC-Telegramme doppelt desendet werden -->4..8  


//#define LCD2SERIAL          // leite Ausgaben zu Serial um (kein Display)

//#define ANDREAS             // Ausgabe eines HIGH-Signals auf zwei Pins, wenn eine Lok aus einer von zwei Gruppen detektiert wurde (Muster)
//#define WENDE             // Wendeschleifenfunktion, Ansteuerung eines  BISTABILEN Relais mit HIGH-Signal auf zwei Pins, wenn eine Lok aus einem oder anderem Abschnitt detektiert wird (Muster)
#define MIRKO               // Ansteuerung von Zubehör via LocoNet in Abhängigkeit der Belegung mit bestimmter Lokaddresse und Blockbelegung eines anderen Abschnittes (Muster)

#else                            // vordefiniert für DigiSpark
#define ANALOGREADPIN 2   // DigiSpark => 2
#define UDETECT00 324  // DigiSpark-Nullabgleich: zum Testen auskommentieren, Wert aus Display ablesen und hier eintragen
int ux0[1] = {UDETECT00};
int noschottky[1] = {0};

#define REMOVEDELAYMS 1500
#define RCONDELAY             // Eintrag erst bei 2. Erscheinen, Versuch Phantome zu verhindern
//aus Kompatibilitätsgründen ...
#define FIRSTBLOCKADDR 1    // Adresse des ersten Rückmelders mit 1 beginnend
#define BLOCKANZ 1          // Anzahl Rückmelder (1 .. 8)
#define LCDANZPIN 0         // Adresse per LCD anzuzeigenden Rückmeldeabschnitts mit 0 beginnend

#define LCD                 // muss extra ab 2020-03-22 (V38)

#endif



//  ################  Ende Konfiguration - ab hier nicht ändern #############

//#define DEBUG
//#define DEBUG2   // Zeigt DCC von fehlerhaften Besetztmeldungen
#define DEBUGIF true                    //Immer
//#define DEBUGIF Addr!=88&&Addr!=87&&Addr!=13&&Addr!=60&&Addr!=31&&Addr!=1
//#define DEBUGIF Addr!=9999&&Addr!=87    //nicht bei ausgewaehlten Loks
//#define DEBUGIF Addr==87||Addr==13       //nur bei ausgewaehlten Loks
//#define DEBUGIF Addr==3       //nur bei ausgewaehlten Loks
//#define DEBUGIF Addr==9999       //nur bei ausgewaehlten Loks >>
//#define DEBUGIF Addr==87       //nur bei ausgewaehlten Loks >>

//#define PINDEBUG // Test zur Signalausgabe auf Pins für Logic-Analysator
//#define NOSCHOTTKY      // Pin 5 und 7 testweise mit N4001 !!!, kann ggf bei "autodetect" weggelassen werden
//  #define NMRADCC121   obsolet ???      //Verwendung der NMRADCC-Lib Version 1.2.1 (empfohlen für I2C-Display)

// LCDLCD-I2C-Anzeige oder wenn LCD2SERIAL auskommentiert:
// in wiring.c #define ENABLE_IE aktivieren ???, DCC-IN über Optokoppler 6N136/6N137 verstärken oder reicht 10k gen GND ???
#ifndef LCD2SERIAL
#undef  ANDREAS
//#define REMOVEDELAYMS 1400 //=2400 Ausschaltverzögerung in ms, für LCD-Display oder sehr viele Loks
//#undef RCONDELAY       // 2019-06-30, Test Eintrag erst bei 2. Erscheinen, Versuch Phantome zu verhindern
#define REMOVEONLYWITHADDR 3  //=3 geht erst wenn Adresse x-mal ohne RC-Quitt aufgerufen 
// ---> #define ENABLE_IE in wiring.c (siehe unten)
#endif

// Entferne Lok aus Liste nur wenn mindestens 2x ... 10x  erfolglos angesprochen
// Anzahl ERFOLGLOSER(!!!) DCC-Aufrufe auf Lok bevor diese entfernt wird
#ifndef REMOVEONLYWITHADDR
#endif
#if REMOVEONLYWITHADDR == 0
#define REMOVEONLYWITHADDR 1
#endif

// Ausschaltverzögerung in ms - min 50 ms, NANO ohne LCD mit //#ifdef ENABLE_IE 150, mit LCD und #ifdef ENABLE_IE 2000
#ifndef REMOVEDELAYMS
#define REMOVEDELAYMS 50
#endif

#ifdef INVERTBLOCKADDR
#define INVERTBLOCKADDR -1
#else
#define INVERTBLOCKADDR 1
#endif


#include <NmraDcc.h>
// die NmraDCC - Library gibt es unter https://github.com/mrrwa/NmraDCC/archive/master.zip oder https://github.com/mrrwa/NmraDcc/releases

#define DCC_DECODER_VERSION_ID 02 // Versions-ID zur Speicherung in CV 7

short werte[50];  //50 = 6280, 319  ->5 6280, 229
short werte_i;

byte belegt = 0;     // bitweise Belegung der einzelnen Abschnitte
byte belegtOld = 0;  // vorangegangender Zustand
byte belegtInit = 0xFF;  // Zustand noch nicht gemeldet
byte belegtInitDelay = 0;

int u0 = 0;  // Nullwert

int u00 = 0; // Nullwert für Initialisierung im setup (6)

byte posX[4] = {0, 8, 0, 8};
byte posY[4] = {0, 0, 1, 1};
char cDir[3] = {'<', ' ', '>'};
//byte cDir[4] = "< >";

//byte
int  LokRCtime[5 * BLOCKANZ] = {0, 0, 0, 0, 0}; // n+1 da so Auswertelogik unten einfacher, --> weniger Programmspeicherbedarf
int  LokRCaddr[5 * BLOCKANZ] = {0, 0, 0, 0, 0};
char LokRCdir [5 * BLOCKANZ] = {0, 0, 0, 0, 0};

byte i2cON = 0;

//#define LOCONET
#if defined(LOCONET)
//  Testweise
//  #define REMOVEDELAYMS 500 // Ausschaltverzögerung in ms
//  #define REMOVEONLYWITHADDR 3  // Anzahl ERFOLGLOSER(!!!) DCC-Aufrufe auf Lok bevor diese entfernt wird

#include <LocoNet.h>
#define  RX_BUF_LOW   32
#define  RX_BUF_HIGH  96
#define  TX_PIN   13//6
static   LnBuf        LnTxBuffer ;
static   lnMsg        *LnPacket;


// Loconet turnout position definitions to make code easier to read
#define TURNOUT_NORMAL     1  // aka closed
#define TURNOUT_DIVERGING  0  // thrown

// Construct a Loconet packet that requests a turnout to set/change its state
void sendOPC_SW_REQ(int address, byte dir, byte on) {
    lnMsg SendPacket ;
    
    int sw2 = 0x00;
    if (dir == TURNOUT_NORMAL) { sw2 |= B00100000; }
    if (on) { sw2 |= B00010000; }
    sw2 |= (address >> 7) & 0x0F;
    
    SendPacket.data[ 0 ] = OPC_SW_REQ ;
    SendPacket.data[ 1 ] = address & 0x7F ;
    SendPacket.data[ 2 ] = sw2 ;
    
//    LocoNet.send( &SendPacket );
    LocoNet_sendX( &SendPacket );
}
// Some turnout decoders (DS54?) can use solenoids, this code emulates the digitrax 
// throttles in toggling the "power" bit to cause a pulse
void setLNTurnout(int address, byte dir) {
    sendOPC_SW_REQ(address - 1, dir, 1);
    sendOPC_SW_REQ(address - 1, dir, 0);
}
bool isInList(short such, const short * arr, int num)
{
  for(int i = 0; i<num;i++) {
    if(such == arr[i]) return true;
  }
  return false;
}
#define ISINLIST(su, list) (isInList(su, list, sizeof(list)/sizeof(list[0])) )


//wiederholtes Senden wenn lnMsg nicht OnWire
void LocoNet_sendX(lnMsg * SendPacket) {
  //      LocoNet.send( SendPacket ) ;  //checksum wird automatisch berechnet
  lnMsg * LnPacket;
  short lnMsgNotOnWire = 10;    // Anzahl der Sendeversuche
  while((lnMsgNotOnWire--)>0) {
    LocoNet.send( SendPacket ) ;  //checksum wird automatisch berechnet
    while( LnPacket = LocoNet.receive() ) {
      if((getLnMsgSize(SendPacket)==getLnMsgSize(LnPacket)) ) {
        for(int i = 0; i<getLnMsgSize(SendPacket); i++) {
          if(SendPacket->data[0]!=LnPacket->data[0]) break;
          if(i==getLnMsgSize(SendPacket)-1) lnMsgNotOnWire = 0; 
        }
      }
    }
    #ifdef LCD2SERIAL
    if(lnMsgNotOnWire) {
      Serial.print("ERROR # ");   //nur für Debug
    }
    #endif
  }

}
#endif


// folgendes in LiquidCrystal_SoftWire.h anpassen (DIGISPARK)
#if defined(__AVR_ATmega328P__)  // NANO
#define SDA_PIN 4
#define SDA_PORT PORTD
#define SCL_PIN 3
#define SCL_PORT PORTD
#else              // DigiSPARK
#define SDA_PIN 1
#define SDA_PORT PORTB
#define SCL_PIN 3
#define SCL_PORT PORTB
#undef OLEDDISPLAY
#endif
#ifndef TCAADDR
  #define TCAADDR 0
#endif
#ifndef NRSTELLEN
  #define NRSTELLEN 4
#endif
#ifndef LCDANZPIN
  #ifdef EINZEILIG
    #define LCDANZPIN 0
  #else
    #define LCDANZPIN 0x1FF
  #endif
#endif

// internal R in Lib SoftI2CMaster.h aktivieren !!!
// #define I2C_PULLUP 1

uint8_t I2c_Address = 0;
uint8_t I2c_Type = 0;

#if !defined(PINDEBUG) /*&& !defined(ANDREAS)*/ && !defined(LCD2SERIAL) && defined(LCD)
  #include <LiquidCrystal_SoftWire.h> // Vorher hinzugefügte LiquidCrystal_AvrI2c Bibliothek einbinden
  LiquidCrystal_SoftWire lcd(I2CADDR, 16, 2); //Hier wird festgelegt um welches Display es sich handelt. Die HEX-Adresse 0x27 ist eine Standartadresse für LCD mit einem einfachen I²C-Modul auf der Rückseite. Wenn das I²C Modul Lötstellen zur Veränderung der HEX-Adresse aufweist, ist die Standartadresse "0x3F". In diesem Fall handelt es sich um ein LCD mit 16 Zeichen in 2 Zeilen (16,2). Für ein vierzeiliges AvrI2c-LCD verwendet man den Code "LiquidCrystal_AvrI2c lcd(0x27, 20, 4)".
#endif
#if !defined(PINDEBUG) /*&& !defined(ANDREAS)*/ && !defined(LCD2SERIAL) && defined(OLEDDISPLAY)
  #include "SSD1306AsciiSoftWire.h"
  SSD1306AsciiSoftWire oled;
#endif

// Funktionen zur Erkennung des Frei- oder Belegtzustandes
// eines Abschnittes 0 .. 7 für A0 .. A7
bool isAbschnittBelegt(byte i) {
  return (bool)  (belegt & (1 << i));
}
bool isAbschnittFrei(byte i) {
  return (bool)  !(belegt & (1 << i));
}
bool isAbschnittBelegtGekommen(byte i) {
  return (bool)  (belegt & (1 << i)) && !(belegtOld & (1 << i));
}
bool isAbschnittFreiGegangen(byte i) {
  return (bool)  !(belegt & (1 << i)) && (belegtOld & (1 << i));
}

// eines Blocks 1 .. 
bool isBlockBelegt(short i) {
//return (bool)  (belegt & (1 << (i - FIRSTBLOCKADDR)));
  return (bool)  (belegt & (1 << (i*INVERTBLOCKADDR - FIRSTBLOCKADDR *INVERTBLOCKADDR)));
}
bool isBlockFrei(short i) {
//return (bool)  !(belegt & (1 << (i - FIRSTBLOCKADDR)));
  return (bool)  !(belegt & (1 << (i*INVERTBLOCKADDR - FIRSTBLOCKADDR *INVERTBLOCKADDR)));
}




NmraDcc DCC;
//////////////////////////////////////////////////////////////

void setup() {
delay(100*FIRSTBLOCKADDR);  //2019-12-22 verbessertes Init

#ifdef LCD2SERIAL
  Serial.begin(250000);
#endif
#ifdef DEBUG
  Serial.begin(250000);
#endif

  char st[50];
#if !defined(PINDEBUG) /*&& !defined(ANDREAS)*/ && !defined(LCD2SERIAL) && defined(OLEDDISPLAY)

  for(int i = 0;i<=7;i++)
  {
    for(int j = 0;j<=i;j++) // vermeide doppeltes init
    {
      if(i==j)
      {
        byte isoled = 0;
        if(TCAADDR) oled.tcaSelect(TCAADDR, chanDispMultiplex[i]);
        if((chanDispTyp[i] == 100 + I2CTYPEOLED128x32)||(chanDispTyp[i] == I2CTYPEOLED128x32))
        {
          oled.begin(&Adafruit128x32, chanDispAddr[i]);
          isoled = 1;
        }
        else if((chanDispTyp[i] == 100 + I2CTYPEOLED128x64)||(chanDispTyp[i] == I2CTYPEOLED128x64))
        {
          oled.begin(&Adafruit128x64, chanDispAddr[i]);
          isoled = 1;
        }
        if(isoled && (chanDispTyp[i] > 100))
        {
          // Rotate display 180 degrees, connection pins at bottom
          oled.ssd1306WriteCmd(SSD1306_SEGREMAP); // colAddr 0 mapped to SEG0 (RESET)
          oled.ssd1306WriteCmd(SSD1306_COMSCANINC); // Scan from COM0 to COM[N â€“1], normal (RESET)
        }
        if(isoled)
        {
          oled.setFont(System5x7);
          oled.clear();
          oled.print("128x");
          if(chanDispTyp[i]>=100) oled.print(chanDispTyp[i]-100);
          else                    oled.print(chanDispTyp[i]);
          oled.print(" ==>");
          oled.print(chanDispMultiplex[i]);
          oled.print(" #");
          oled.print(chanDispAddr[i]);
          oled.print("\n\n");
          //oled.print("RCdec-nano-test39_LCD-Test.ino");
          oled.print(&((char *)__FILE__)[strlen(__FILE__)-26]);
          oled.print("\n");
          oled.print(__DATE__);
          oled.print(" ");
          oled.print(__TIME__);
        }
       
      }
      else if((chanDispAddr[i] == chanDispAddr[j])&&(chanDispMultiplex[i] == chanDispMultiplex[j])) break; // bereits initialisiert 
    }
  }
  #ifdef CLEARINITSCREEN  
  delay(CLEARINITSCREEN *1000+1);
  // Loeschen der Displays
  for(int i = 0;i<=7;i++)
  {
    for(int j = 0;j<=i;j++) // vermeide doppeltes init
    {
      if(i==j)
      {
        oled.changeDisplayAddr(chanDispAddr[i]);
        if(TCAADDR) oled.tcaSelect(TCAADDR, chanDispMultiplex[i]);
        oled.clear();
      }
      else if((chanDispAddr[i] == chanDispAddr[j])&&(chanDispMultiplex[i] == chanDispMultiplex[j])) break; // bereits geloescht 
    }
  }
  #endif



#endif
#if !defined(PINDEBUG) /*&& !defined(ANDREAS)*/ && !defined(LCD2SERIAL) && defined(LCD)
//  if(!I2c_Address) {  //OLED gefunden
//    I2c_Address = getAvrI2cAdress(0x20, 0x28);  // 3 Pin/Bit zur Adresswahl
//    if(!I2c_Address) I2c_Address = getAvrI2cAdress(0x3f, 0x47);  // 2019-03-05 erweiterter Adressraum LCD mit PCF8574A, 3 Pin/Bit zur Adresswahl

//  I2c_Address = getAvrI2cAdress(60, 62);  // 1 Pin/Bit zur Adresswahl
  I2c_Address = I2CADDR;
  if(I2c_Address) { 
//    I2c_Type    = getAvrI2cType(I2c_Address);
    lcd = LiquidCrystal_SoftWire(I2CADDR, 16, 2); //Hier wird festgelegt um welches Display es sich handelt. Die HEX-Adresse 0x27 ist eine Standartadresse für LCD mit einem einfachen I²C-Modul auf der Rückseite. Wenn das I²C Modul Lötstellen zur Veränderung der HEX-Adresse aufweist, ist die Standartadresse "0x3F". In diesem Fall handelt es sich um ein LCD mit 16 Zeichen in 2 Zeilen (16,2). Für ein vierzeiliges AvrI2c-LCD verwendet man den Code "LiquidCrystal_AvrI2c lcd(0x27, 20, 4)".
    lcd.init(); //Im Setup wird der LCD gestartet
    lcd.backlight(); //Hintergrundbeleuchtung einschalten (lcd.noBacklight(); schaltet die Beleuchtung aus).
    //  lcd.setCursor(0, 0);
    lcd.clear();
  }
//}  
#endif

  /////////////////////////////////////////////////
  // internal R in Lib aktivieren !!!

#if defined(__AVR_ATmega328P__)  // NANO
  //  analogReference(INTERNAL);
  analogReference(EXTERNAL);
  for (int i = 0; i < BLOCKANZ; i++) {
    //  pinMode(ANALOGREADPIN , INPUT_PULLUP);    // RC in, mit ANALOGREADPIN = A0 ... A7, 2019-08-14 geht nicht wg. Interrupt-Analog-Read
    pinMode(i + 14 + ANALOGREADPIN , INPUT_PULLUP); // RC in, mit ANALOGREADPIN = 0 ... 7
  }
#else
  analogReference(INTERNAL2V56);   //  keine Ausgabe, SCL Pin3 Ausgabe 244 ohne, ... 252 mit ADCSRA, 316/318 am DCC
  //  analogReference(INTERNAL1V1);      // ohne ADCSRA Ausgabe 574 bei 5,6 k, 1023 bei 22 k, mit ADCSRA 1023 ???
  //  analogReference(INTERNAL);
  pinMode(4 , INPUT_PULLUP);    // RC in
#endif


  ADCSRA =  bit (ADEN);   // turn ADC on
  //  ADCSRA &= ~(bit (ADPS0) | bit (ADPS1) | bit (ADPS2)); // clear prescaler bits

  ////  ADCSRA |= bit (ADPS0);                               //   2 (  1.625 µs)
  //  ADCSRA |= bit (ADPS1);                               //   4 (  3.25  Âµs)
  //  ADCSRA |= bit (ADPS0) | bit (ADPS1);                 //   8 (  6.5   Âµs)
  ADCSRA |= bit (ADPS2);                               //  16 ( 13     Âµs)
  //  ADCSRA |= bit (ADPS0) | bit (ADPS2);                 //  32 ( 26     Âµs)
  //  ADCSRA |= bit (ADPS1) | bit (ADPS2);                 //  64 ( 52     Âµs)
  //  ADCSRA |= bit (ADPS0) | bit (ADPS1) | bit (ADPS2);   // 128 (104     Âµs)

  DCC.init( MAN_ID_DIY, DCC_DECODER_VERSION_ID, 0, 0);//FLAGS_OUTPUT_ADDRESS_MODE | FLAGS_DCC_ACCESSORY_DECODER,0 );
  DCC.pin(0, 2, 1); // DCC-Signal an Pin2 ( = Int0 );

#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
  //  cbi (TIMSK0, TOIE0); // disable Timer0 !!! delay() is now not available
  //  TIMSK0 &= ~_BV(TOIE0); // disable timer0 overflow interrupt


#if defined(PINDEBUG) || defined(ANDREAS) || defined(WENDE)
  //  pinMode(0 , OUTPUT);    //
  pinMode(1 , OUTPUT);    //
  pinMode(3 , OUTPUT);    //
  pinMode(4 , OUTPUT);    //
  //  digitalWrite(0, 0);
  digitalWrite(1, 0);

#if defined(__AVR_ATmega328P__)  // NANO
  pinMode(3 , OUTPUT);    //
  pinMode(4 , OUTPUT);    //
  digitalWrite(3, 0);
  digitalWrite(4, 0);
#endif

#endif


#ifdef UDETECT00
  u0 = UDETECT00;
#endif

#if defined(LOCONET)
  // First initialize the LocoNet interface, specifying the TX Pin
  LocoNet.init(TX_PIN);
  // Initialize a LocoNet packet buffer to buffer bytes from the PC
  initLnBuf(&LnTxBuffer) ;
#endif

#if BLOCKANZ > 1
//  for (int i = 5; i < 5 * BLOCKANZ; i++) {  2019-12-22
  for (int i = 0; i < 5 * BLOCKANZ; i++) {
    LokRCtime[i] = 0;
    LokRCaddr[i] = 0;
    LokRCdir[i] = 0;
  }
#endif

  pinMode(3 , OUTPUT);    //
  pinMode(7 , OUTPUT);    //
}


#ifdef LOCONET
#define MAX_DCC_SHORT_ADDRESS 99    //Maximum of short DCC Address, from the next on use LONG ADDRESS!
void lnSendImmPacketToDcc(uint16_t Addr, uint16_t d1 = 0x8000, uint16_t d2 = 0x8000, uint16_t d3 = 0x8000)
{
  uint8_t anzDatBytes;
  if(d3 != 0x8000) anzDatBytes = 3;
  else if(d2 != 0x8000) anzDatBytes = 2;
  else if(d1 != 0x8000) anzDatBytes = 1;
  else anzDatBytes = 1;
  
  lnMsg SendPacket ;
  SendPacket.data[ 0 ] = 0xED ;                                                               //OPC_IMM_PACET
  SendPacket.data[ 1 ] = 0x0B ;                                                               //mesg_size;     // ummmmm, size of the message in bytes?
  SendPacket.data[ 2 ] = 0x7F ;                                                               //val7f;         // fixed value of 0x7f
  SendPacket.data[ 3 ] = 0x0f | ((((anzDatBytes)+1+(Addr>MAX_DCC_SHORT_ADDRESS))&0x0F)<<4) ;  //reps;          // <REPS> D4,5,6=#IM bytes,D3=0(reserved); D2,1,0=repeat CNT  repeat count
  SendPacket.data[ 4 ] = 0x00 ; //0x20 ???                                                    //dhi;           // <DHI>=<0,0,1,IM5.7-IM4.7,IM3.7,IM2.7,IM1.7>  high bits of data bytes

  if (Addr>MAX_DCC_SHORT_ADDRESS) //This is a 14-bit address
  {
    SendPacket.data[ 5 ] = (uint8_t)(((Addr >> 8) | 0xC0) & 0x7F);
    SendPacket.data[ 6 ] = (uint8_t)((Addr & 0xFF) & 0x7F);

    SendPacket.data[ 4 ] |= (uint8_t)((((Addr >> 8) | 0xC0) & 0x80)>>7);
    SendPacket.data[ 4 ] |= (uint8_t)( ((Addr & 0xFF) & 0x80)>>6);
  } else //we have an 7-bit address
  {
    SendPacket.data[ 5 ] =  (uint8_t)(Addr & 0x7F);
  }

  SendPacket.data[ 6+(Addr>MAX_DCC_SHORT_ADDRESS) ] = (d1& 0x7F);
  SendPacket.data[ 4 ] |= (uint8_t)((d1 & 0x80)>>(6- (Addr>MAX_DCC_SHORT_ADDRESS)) );

  SendPacket.data[ 7+(Addr>MAX_DCC_SHORT_ADDRESS) ] = (d2& 0x7F);
  SendPacket.data[ 4 ] |= (uint8_t)((d2 & 0x80)>>(5- (Addr>MAX_DCC_SHORT_ADDRESS) ));

  SendPacket.data[ 9 ] = 0x00 ;  //Voreinst für kurze Addr
  SendPacket.data[ 8+(Addr>MAX_DCC_SHORT_ADDRESS) ] = (d3& 0x7F);
  SendPacket.data[ 4 ] |= (uint8_t)((d3 & 0x80)>>(4- (Addr>MAX_DCC_SHORT_ADDRESS) ));

  SendPacket.data[ 10 ] = 0x00 ;
  SendPacket.data[ 11 ] = 0x00 ;

//  LocoNet.send( &SendPacket ) ;  //checksum wird automatisch berechnet
  LocoNet_sendX( &SendPacket ) ;  //checksum wird automatisch berechnet
}
#endif


////////////////////////////////////////////////////////////////
void loop() {

#ifdef UDETECT00
  DCC.process(); // Hier werden die empfangenen Telegramme analysiert

#elif !defined(PINDEBUG)
  //#define DETAILS
#ifdef DETAILS
  //  delay(500);
  static long summ = 0;
  static long anz = 0;
  static long summ_max = 0;
  static long anz_max = 0;
  static long summ_min = 0;
  static long anz_min = 0;

  int v = analogRead(ANALOGREADPIN);
  //  int v = micros()/1000000;

  summ += v;
  anz++;
  if (v > (summ / anz) + 50) {
    summ_max += v;
    anz_max++;
  }
  if (v < (summ / anz) - 50) {
    summ_min += v;
    anz_min++;
  }


  if (anz % 5000 == 0)
  {
    char buffer[16];          //  14 Byte
    lcd.setCursor(0, 0);     //  10 Byte
    itoa(v, buffer, 10);      // 106 Byte
    lcd.print(buffer);       //  40 Byte

    lcd.setCursor(8, 0);     //  10 Byte
    itoa(anz / 1000, buffer, 10);    // 106 Byte
    lcd.print(buffer);       //  40 Byte
    lcd.print(" 000");       //  40 Byte


    lcd.setCursor(0, 1);     //  10 Byte
    itoa((summ_min / anz_min), buffer, 10);    // 106 Byte
    lcd.print(buffer);       //  40 Byte

    lcd.setCursor(5, 1);     //  10 Byte
    itoa((summ / anz), buffer, 10);    // 106 Byte
    lcd.print(buffer);       //  40 Byte

    lcd.setCursor(10, 1);     //  10 Byte
    itoa((summ_max / anz_max), buffer, 10);    // 106 Byte
    lcd.print(buffer);       //  40 Byte

  }
#else
  char buffer[16];          //  14 Byte
#if BLOCKANZ == 1
  delay(500);

  // Umstellung auf Interrupt 2019-08-14
  werte_i = 0;
  ADCSRB = 0;
#if defined(__AVR_ATmega328P__)  // NANO
  //  analogReference(EXTERNAL);
  ADMUX =   (ANALOGREADPIN & 0x07);  // ARef extern
#else
  //  analogReference(INTERNAL2V56);   //  keine Ausgabe, SCL Pin3 Ausgabe 244 ohne, ... 252 mit ADCSRA, 316/318 am DCC
  ADMUX =   (ANALOGREADPIN & 0x07) | (1 << REFS0) | (1  << REFS1) | (1  << REFS2); // ARef 2,56V
#endif
  ADCSRA |= (1 << ADIE);  // Enable ADC Interrupt
  bitSet (ADCSRA, ADSC);  // start a conversion
  while (!bit_is_clear(ADCSRA, ADSC)) {};
  int v = werte[0];
  //    int v = analogRead(ANALOGREADPIN);

#ifdef LCD2SERIAL
  Serial.print("UDETECT00 ");
  Serial.println(v);
#else
  lcd.setCursor(0, 0);     //  10 Byte
  lcd.print("UDETECT00 ");
  itoa(v, buffer, 10);      // 106 Byte
  lcd.print(buffer);       //  40 Byte
#endif
#else
  delay(500);
#ifdef LCD2SERIAL
  Serial.print("int ux0[8] = {");
#else
//  lcd.setCursor(0, 0);     //  10 Byte
  lcd.print("");
  oled_clear();
#endif
  for (int p = 0; p < BLOCKANZ; p++) {
    long summ = 0;
    for (int i = 0; i < 128; i++) {
#if defined(__AVR_ATmega328P__)  // NANO
      analogReference(EXTERNAL);
#else
      analogReference(INTERNAL2V56);   //  keine Ausgabe, SCL Pin3 Ausgabe 244 ohne, ... 252 mit ADCSRA, 316/318 am DCC
#endif
      summ += analogRead(p + ANALOGREADPIN);
    }
#ifdef LCD2SERIAL
    Serial.print(summ / 128);
    if (p < 7) Serial.print(", ");
#else
    itoa(summ / 128, buffer, 10);      // 106 Byte
    #ifdef LCD
      lcd.print(buffer);       //  40 Byte
      if (p < 7) lcd.print(",");
      if (p == 3) lcd.setCursor(0, 1);
    #endif
    #ifdef OLEDDISPLAY
      oled_print(buffer);
      if (p < 7) oled_print(",");
      if (p == 3) oled_print("\n");
    #endif
#endif
  }
  Serial.println("};");
#endif


#endif

#endif
}


//////////////////////////////////////////////////////////////
// Unterprogramme, die von der DCC Library aufgerufen werden:
// Die folgenden Funktionen wird von DCC.process() aufgerufen, wenn ein Loktelegramm empfangen wurde

void notifyDccFunc( uint16_t Addr, DCC_ADDR_TYPE AddrType, FN_GROUP FuncGrp, uint8_t FuncState) {
  //  TIMSK0 &= ~_BV(TOIE0); // disable timer0 overflow interrupt
  checkRC(Addr);
  //  TIMSK0 |= _BV(TOIE0);  // enable timer0 overflow interrupt
}


void notifyDccSpeed( uint16_t Addr, DCC_ADDR_TYPE AddrType, uint8_t Speed, DCC_DIRECTION Dir, DCC_SPEED_STEPS SpeedSteps ) {
  //  TIMSK0 &= ~_BV(TOIE0); // disable timer0 overflow interrupt
  checkRC(Addr);
  //  TIMSK0 |= _BV(TOIE0);  // enable timer0 overflow interrupt
}


void checkRC(uint16_t Addr)  {
  long ti0 = micros(); // Zeit vom Anfang der Funktion 
  
  static long countR  = 0;
  static long mittelR = 0;

  char buffer[16] = "        ";          //  14 Byte
  int dir = 0;
  int dirL = 0;   //2019-06-30: erlaubt differenziertere Auswertung und Fehlererkennung
  int dirR = 0;

  static byte searchChan = 0; //Kanal der für alle Adressen einmal drchlaufen wird
  static byte searchChanFix = 0;
  static byte aktChan = 0;    //Kanal mit dem aktuell gearbeitet wird
  static short lokMax = 0;
  static short lokLast = 0;

  bool boChange = false;
  int gegangenLokRCaddr = 0;
  int gekommenLokRCaddr = 0;
  char gekommenLokRCdir = 0;

  
#if UDETECT00>20
  
//      digitalWrite(7, Addr==31);    

  //Serial.println(Addr);   return;
  //if(Addr==9999||Addr==87) return;
  //static short acount=0;acount++;if(Addr==9999){if(acount!=101&&acount!=8)Serial.println(acount);acount=0;return;}

  //Störunterdrückung III, i2cON mal keine RC-Auswertung, verhindert Übersprechen nach I2C-Übertragung
  if (i2cON) {
    i2cON--;
#ifdef DEBUG
    if (DEBUGIF)
      Serial.println(Addr);
#endif
    return;
  }

  int v0;
  static long summ = 0;
  static long anz = 0;
  long ti;

  //    short werte[50];
  //    short werte_i = 0;
  werte_i = 0;

#ifdef NOSCHOTTKY
#define NOSCHOTTKY 50
#else
#define NOSCHOTTKY 0
#endif

  //cli();  //2019-08-14 für Interrupt n. E.

#ifdef DETECT8KANAL
  
    // Test: Simuliere 8-kanal RC-Melder
    //       if(lokMax==Addr) aktChan = (aktChan+1)&7;
    //       if(aktChan) {sei(); return;}


  if (lokMax < Addr) lokMax = Addr;
  
  for(aktChan = 0;aktChan < BLOCKANZ;aktChan++)
  {
    //    if((LokRCaddr[0]==Addr)||(LokRCaddr[1]==Addr)||(LokRCaddr[2]==Addr)||(LokRCaddr[3]==Addr)) {;
    if ((LokRCaddr[0 + 5 * aktChan] == Addr) || (LokRCaddr[1 + 5 * aktChan] == Addr) || (LokRCaddr[2 + 5 * aktChan] == Addr) || (LokRCaddr[3 + 5 * aktChan] == Addr)) break;
  }

  if(aktChan>= BLOCKANZ) {
//    if (lokMax == Addr) {
    if ((lokMax == Addr)&&(Addr != lokLast)) {   // fuer roco z21, doppelte DCC-Telegramme
      if (searchChanFix == 0) { // bewusstes fixieren eines Kanals für eine bestimmte Anzahl Durchlaeufe
        searchChan++;
        if (searchChan >= BLOCKANZ) searchChan = 0;
      }
      else searchChanFix--;
    }
    aktChan = searchChan;
  }
  lokLast = Addr;
#endif



  // Umstellung auf Interrupt 2019-08-14
  ADCSRB = 0;
#if defined(__AVR_ATmega328P__)  // NANO
  //  analogReference(EXTERNAL);
  ADMUX =   ((aktChan + ANALOGREADPIN) & 0x07); // ARef extern
#else
  //  analogReference(INTERNAL2V56);   //  keine Ausgabe, SCL Pin3 Ausgabe 244 ohne, ... 252 mit ADCSRA, 316/318 am DCC
  ADMUX =   (ANALOGREADPIN & 0x07) | (0 << REFS0) | (1  << REFS1) | (1  << REFS2); // ARef 2,56V
#endif
  //    ADMUX =   (ANALOGREADPIN & 0x07);  // ARef extern
  //    ADMUX =   bit (REFS0) | (ANALOGREADPIN & 0x07);  // AVcc
  ADCSRA |= (1 << ADIE);  // Enable ADC Interrupt

  //#define TEST AR1
#ifdef AR1
  delayMicroseconds(34);  //test NANO
  delayMicroseconds(100 + 15); //test NANO
#else
  ti = micros();

  // Umstellung auf Interrupt 2019-08-14
  bitSet (ADCSRA, ADSC);  // start a conversion
  while (!bit_is_clear(ADCSRA, ADSC)) {};
  //     analogRead(ANALOGREADPIN);

#ifndef DETECT8KANAL
  // Umstellung auf Interrupt 2019-08-14
  bitSet (ADCSRA, ADSC);  // start a conversion
  while (!bit_is_clear(ADCSRA, ADSC)) {};
  //     analogRead(ANALOGREADPIN);

  //     analogRead(ANALOGREADPIN);
  //     analogRead(ANALOGREADPIN);
#endif



  // Umstellung auf Interrupt 2019-08-14
  ADCSRA |= (1 << ADATE);  // set ADC Auto Trigger Enable
  //    ADCSRA |= (1 << ADFR);  // set ADC as free-running
  werte_i = 0;

#ifdef NMRADCC121
  //       while(ti+34+100+15+2*20 >micros()) {};  // NANO+NMRA-Lib 1.2.1            !!!GRENZWERT!!!  //besser für LCD
//  while (ti + 34 + 100 + 15 + 1 * 20 > micros()) {}; // NANO+NMRA-Lib 1.2.1            !!!GRENZWERT!!!  //besser für LCD
//  while (0-64-16   + ti0 + 16 + 34 + 100 + 15 + 1 * 20 > micros()) {}; // NANO+NMRA-Lib 1.2.1            !!!GRENZWERT!!!  //besser für LCD
  while (ti0 + 121 -16 > micros()) {}; // NANO+NMRA-Lib 1.2.1            !!!GRENZWERT!!!  //besser für LCD
#else
//  while (ti + 34 + 100 + 15 + 1 * 20 > micros()) {}; // NANO+NMRA-Lib 1.4.2, 2.0.0 ...   !!!GRENZWERT!!!
//  while (0-64   + ti0 + 16 + 34 + 100 + 15 + 1 * 20 > micros()) {}; // NANO+NMRA-Lib 1.4.2, 2.0.0 ...   !!!GRENZWERT!!!
  while (ti0 + 121 > micros()) {}; // NANO+NMRA-Lib 1.2.1            !!!GRENZWERT!!!  //besser für LCD
#endif
#endif

  ti = micros();

  bitSet (ADCSRA, ADSC);  // start a conversion

#ifdef NMRADCC121
  while (ti + 290 - 150 + 6 * 20 > micros()) { // NANO+NMRA-Lib 1.2.1           !!!GRENZWERT!!!  //besser für LCD
#else
  while (ti + 290 - 150 + 4 * 20 > micros()) { // NANO+NMRA-Lib 1.4.2, 2.0.0 ...  !!!GRENZWERT!!!
#endif


  }
  ADCSRA &= ~(bit (ADATE));   // stop a conversion

  //sei();  //2019-08-14 für Interrupt n. E.

#ifdef DEBUG
  if (DEBUGIF) {

    Serial.print(Addr);
    Serial.print(",");
//    Serial.print(aktChan);
//    Serial.print(":");
  }
#endif

  long countRold  = countR;
  long mittelRold = mittelR;

  //    for(int j = 0; j< werte_i;j++)
  //2019-08-14 Umstellung auf Interrupt, verwerfe die ersten beiden MW
  for (int j = 2; j < werte_i; j++)
  {
#ifdef UDETECT00

    //2019-08-14: Abfrage mit Interrupt
    if ((werte[j] < (ux0[aktChan] - 30 - NOSCHOTTKY))) dirL += 1; // "<<"
    if ((werte[j] > (ux0[aktChan] + 30 + NOSCHOTTKY))) dirR += 1; // "<<"

    //     if((werte[j]<(u0- 80))&&(werte[j]>(u0- 90))) dirL+=1;    // "<<"
    //     if((werte[j]>(u0+ 70))&&(werte[j]<(u0+ 80))) dirR+=1;    // "<<"

#endif

#ifdef DEBUG
    if (DEBUGIF)
    {
      //      if(((werte[j]>(u0+ 50+NOSCHOTTKY))&&(werte[j]<453))||(werte[j]<(u0- 50-NOSCHOTTKY)))
      
      //if (((werte[j] > (u0 + 20))) || (werte[j] < (u0 - 20)))
      
      ////2019-12-09:angepasst an Abfrage mit Interrupt, s. o.
      if ( ((werte[j] > (ux0[aktChan] + 30 + NOSCHOTTKY))) || ((werte[j] < (ux0[aktChan] - 30 - NOSCHOTTKY))) )
      {
        Serial.print(werte[j]);  Serial.print(", ");
      }
      else
      {
        Serial.print("    , ");
      }
    }
#endif

  }


#ifdef DEBUG2
  if ( ((((dirR - 2 * dirL) < -3) || ((dirR - 2 * dirL) > 3))) && DEBUGIF ) {

    Serial.print(Addr); Serial.print(":");
    for (int j = 0; j < werte_i; j++)
    {
      if (((werte[j] > (u0 + 50 + NOSCHOTTKY))/*&&(werte[j]<453)*/) || (werte[j] < (u0 - 50 - NOSCHOTTKY)))
      {
        Serial.print(werte[j]);  Serial.print(", ");
      }
      else
      {
        Serial.print("    , ");
      }

    }
    //      if(dir) {Serial.print("dir= "); Serial.print(dir);}
    if (dirR - 2 * dirL) {
      Serial.print("dirL= ");
      Serial.print(dirL);
      Serial.print(" dirR= ");
      Serial.print(dirR);
    }
    Serial.println("");
  }
#endif

  //2019-06-30: erlaubt differenziertere Auswertung und Fehlererkennung
  dir = 0;
  if ((dirR - 1 * dirL) > 3) dir = 1; // ">>"
  if ((dirR - 1 * dirL) < -3) dir = -1; // "<<"
  if ( dirR > 2 && dirL > 2)   dir = 0; // FEHLER

  //  if((dirR-1*dirL) < 14) {  // nur SEHR eindeutige Erkennungen zum Abgleich verwenden
  //  if((dirR-1*dirL) < 8) {  // nur eindeutige Erkennungen zum Abgleich verwenden
  //  if(dir!=1) {
  if ((dirR - 1 * dirL) > 4) { // Erkennungen zum Abgleich verwenden
    countR = countRold;
    mittelR = mittelRold;
  }

#ifdef DEBUG
  if (DEBUGIF)
  {
    if (dirR - 2 * dirL) {
      Serial.print("dirL= ");
      Serial.print(dirL);
      Serial.print(" dirR= ");
      Serial.print(dirR);
      Serial.print(" LokRCaddr[0]= ");
      Serial.print(LokRCaddr[0]);
      Serial.print(" LokRCtime[0]= ");
      Serial.print((int)LokRCtime[0]);
    }
    //      if(dir) {Serial.print("dir= "); Serial.print(dir);}
      Serial.print(" dir= ");
      Serial.print(dir);
      Serial.println("");
  }
#endif


//  digitalWrite(3, (Addr==31)&&(dir!=0));    

  byte i;

#ifdef DETECT8KANAL
  for (i = aktChan * 5; i < (aktChan * 5 + 4); i++) {
#else
  for (i = 0; i < 4; i++) {
#endif

#ifdef  REMOVEONLYWITHADDR
    if ((LokRCtime[i] > REMOVEONLYWITHADDR || LokRCdir[i] == 0)&& LokRCtime[i]>0) LokRCtime[i] = LokRCtime[i] - 1;
    else if ( (LokRCaddr[i] == Addr) && LokRCtime[i]>0) LokRCtime[i] = LokRCtime[i] - 1;
#else
    if (LokRCtime[i]>0) LokRCtime[i] = LokRCtime[i] - 1;
#endif

    // 2019-06-30, Test Eintrag erst bei 2. Erscheinen, Versuch Phantome zu verhindern, Ursache: Fehlerkennung in DCC-Lib
    //#define RCONDELAY
#ifdef RCONDELAY
    if ((LokRCaddr[i] == Addr) && (dir)) {

      if (LokRCtime[i] == 254) {
        LokRCdir[i] = cDir[dir + 1];
        boChange = true;
        gekommenLokRCaddr = LokRCaddr[i];
        gekommenLokRCdir = LokRCdir[i];

      //TEST 2019-10-31 erzwingt bei Neudetection einer Lok das Auslesen des gleichen Kanals unmittesbar noch einmal
      //  searchChanFix = 1;
      //  searchChan = aktChan;

      }

//      LokRCtime[i] = 255 - 200;                         // =222, extreme (x2 -> ca. 5 s) Verlängerung der OFF-Zeit
      LokRCtime[i] = 255 - 250 + REMOVEDELAYMS / 10;                     // =222, extreme (x2 -> ca. 5 s) Verlängerung der OFF-Zeit
      if (LokRCdir[i] != cDir[dir + 1]) boChange = true, gekommenLokRCaddr = LokRCaddr[i], gekommenLokRCdir = cDir[dir + 1];
      LokRCdir[i] = cDir[dir + 1];
      break;
    }
    if ((LokRCaddr[i] == 0) && (dir)) {
      LokRCaddr[i] = Addr;
      //        LokRCtime[i]=255-200;
      LokRCtime[i] = 255;
      LokRCdir[i] = 0;
      //        LokRCdir[i] =cDir[dir+1];
      //        boChange = true;
      break;
    }
    if (LokRCtime[i] == 0) {
      if (LokRCaddr[i] != 0 && LokRCdir[i] != 0) {
        gegangenLokRCaddr = LokRCaddr[i];
        boChange = true;
      }
      LokRCaddr[i] = LokRCaddr[i + 1];
      LokRCtime[i] = LokRCtime[i + 1];
      LokRCdir[i] = LokRCdir[i + 1];

      LokRCaddr[i + 1] = 0;
      LokRCtime[i + 1] = 0;
      //LokRCdir[i+1]=' ';
      //if(LokRCtime[i]) LokRCtime[i]=LokRCtime[i]-1;
      dir = 0; // verhindert doppelte Einträge/Neueintrag wenn Lok geht
    }
#else
    if ((LokRCaddr[i] == Addr) && (dir)) {
      LokRCtime[i] = 255 - 250 + REMOVEDELAYMS / 10;                     // =222, extreme (x2 -> ca. 5 s) Verlängerung der OFF-Zeit
      if (LokRCdir[i] != cDir[dir + 1]) boChange = true, gekommenLokRCaddr = LokRCaddr[i], gekommenLokRCdir = cDir[dir + 1];
      LokRCdir[i] = cDir[dir + 1];
      break;
    }
    if ((LokRCaddr[i] == 0) && (dir)) {
      LokRCaddr[i] = Addr;
      LokRCtime[i] = 255 - 250 + REMOVEDELAYMS / 10;
      LokRCdir[i] = cDir[dir + 1];
      boChange = true;
      gekommenLokRCaddr = LokRCaddr[i];
      gekommenLokRCdir = LokRCdir[i];
      break;
    }
    if (LokRCtime[i] == 0) {
      if (LokRCaddr[i] != 0) {
        gegangenLokRCaddr = LokRCaddr[i];
        boChange = true;
      }
      LokRCaddr[i] = LokRCaddr[i + 1];
      LokRCtime[i] = LokRCtime[i + 1];
      LokRCdir[i] = LokRCdir[i + 1];

      LokRCaddr[i + 1] = 0;
      LokRCtime[i + 1] = 0;
      //LokRCdir[i+1]=' ';
      //if(LokRCtime[i]) LokRCtime[i]=LokRCtime[i]-1;
      dir = 0; // verhindert doppelte Einträge/Neueintrag wenn Lok geht
    }
#endif
  }

#ifdef LCD2SERIAL
  /*
          if(boChange) Serial.print(u0);
          if(boChange) Serial.print(" ");
          if(boChange) Serial.print(countR);
          if(boChange) Serial.print(" ");
          if(boChange) Serial.print(mittelR/countR);
          if(boChange) Serial.print(" -");
          if(boChange) Serial.print(belegt);
  */
  if (boChange) Serial.print("#");
  if (boChange) Serial.print(aktChan);

  //2019-12-18 Ausgabe des Blocks
  if (boChange) Serial.print(" (");
  if (boChange) Serial.print(aktChan*INVERTBLOCKADDR + FIRSTBLOCKADDR);
  if (boChange) Serial.print(")");

  if (boChange) Serial.print(" ");

#endif


#if defined(LOCONET)
  lnMsg SendPacket ;

  if (gegangenLokRCaddr) {
    #ifndef RCONLYPRESENT2LN
    SendPacket.data[ 0 ] = 0xE0 ;
    SendPacket.data[ 1 ] = 0x09 ;
    SendPacket.data[ 2 ] = 0x00 + (((aktChan*INVERTBLOCKADDR + FIRSTBLOCKADDR - 1) / 128) & 0x1F) ; // (block-1)/128, 0x20= present=1(belegt), detcode=1, 0x40= present=1(belegt), detcode=2 (speed=dyndyta)
    SendPacket.data[ 3 ] = (aktChan*INVERTBLOCKADDR + FIRSTBLOCKADDR - 1) % 128 ; // (block-1)
    SendPacket.data[ 4 ] = gegangenLokRCaddr / 128 ;  // loco/128
    SendPacket.data[ 5 ] = gegangenLokRCaddr % 128 ;  // loco Modulo 128
    SendPacket.data[ 6 ] = 0x40 ;  // 0x40= pol=1, 0x01= dyndata=0x80, 0x02-0x38 = dynid=1-28
    SendPacket.data[ 7 ] = 0x20 ;  // dyndata 0x00 - 0x7F
//    LocoNet.send( &SendPacket ) ;  //checksum wird automatisch berechnet
    LocoNet_sendX( &SendPacket ) ;  //checksum wird automatisch berechnet
    #endif
  }
  else           //mit else verhält es sich wie DR5088 (Z. B. Wenn eine von 3 loks geht ist der Block leer ... )
    if (gekommenLokRCaddr) {
      SendPacket.data[ 0 ] = 0xE0 ;
      SendPacket.data[ 1 ] = 0x09 ;
      SendPacket.data[ 2 ] = 0x20 + (((aktChan*INVERTBLOCKADDR + FIRSTBLOCKADDR - 1) / 128) & 0x1F) ; // (block-1)/128, 0x20= present=1(belegt), detcode=1, 0x40= present=1(belegt), detcode=2 (speed=dyndyta)
      SendPacket.data[ 3 ] = (aktChan*INVERTBLOCKADDR + FIRSTBLOCKADDR - 1) % 128 ; // (block-1)
      SendPacket.data[ 4 ] = gekommenLokRCaddr / 128 ;  // loco/128
      SendPacket.data[ 5 ] = gekommenLokRCaddr % 128 ;  // loco Modulo 128
      SendPacket.data[ 6 ] = ((gekommenLokRCdir == '>') ? 0x00 : 0x40) ; // 0x40= pol=1, 0x01= dyndata=0x80, 0x02-0x38 = dynid=1-28
      SendPacket.data[ 7 ] = 0x20 ;  // dyndata 0x00 - 0x7F
//      LocoNet.send( &SendPacket ) ;  //checksum wird automatisch berechnet
      LocoNet_sendX( &SendPacket ) ;  //checksum wird automatisch berechnet
    
    }
  i2cON = 0;  //=1 Störunterdrückung III, i2cON mal keine RC-Auswertung, verhindert Übersprechen nach I2C-Übertragung
#endif


#ifdef DETECT8KANAL
  if (boChange) for (i = aktChan * 5; i < (aktChan * 5 + 4); i++) {
#else
  if (boChange) for (i = 0; i < 4; i++) {
#endif
#ifdef LCD2SERIAL
      if (LokRCaddr[i]) {
        buffer[0] = buffer[1] = LokRCdir[i];
        itoa(LokRCaddr[i], &buffer[2], 10);
        buffer[strlen(buffer) + 5] = ' ';
        buffer[strlen(buffer) + 4] = ' ';
        buffer[strlen(buffer) + 3] = ' ';
        buffer[strlen(buffer) + 2] = ' ';
        buffer[strlen(buffer) + 1] = ' ';
        buffer[strlen(buffer)] = ' ';
        buffer[8] = 0;
        Serial.print(buffer);
      }
#endif

#if !defined(PINDEBUG) /*&& !defined(ANDREAS)*/ && !defined(LCD2SERIAL)
    #ifdef OLEDDISPLAY
      #ifdef EINZEILIG  
        if( ((LCDANZPIN * 5)==i) )
        {
          oled.clear();
          if (LokRCaddr[i]) {
            buffer[0] = buffer[1] = LokRCdir[i];
            itoa(LokRCaddr[i], &buffer[2], 10);      // 106 Byte
            buffer[strlen(buffer) + 3] = ' ';
            buffer[strlen(buffer) + 2] = ' ';
            buffer[strlen(buffer) + 1] = ' ';
            buffer[strlen(buffer)] = ' ';
  //          oled.setFont(font5x7);  oled.set2X();
  //          oled.setFont(Callibri11_bold); oled.set2X();
  //          oled.setFont(fixed_bold10x15); oled.set2X();
  //          oled.setFont(TimesNewRoman16); oled.set2X();       
  //          oled.setFont(Roosewood26); oled.set1X();       
  //          oled.setFont(X11fixed7x14); oled.set2X();       
  //          oled.setFont(Callibri15); oled.set2X();
  
  // besser Folgendes
            oled.setFont(ZevvPeep8x16); oled.set2X();       
  //          oled.setFont(CalLite24); oled.set1X();
  
            #ifdef SHOWCHAN
              oled.print(((int)i/5)+((int)SHOWCHAN) );
              oled.print(":");
            #endif
            oled.print(buffer);
            oled.set1X();
            oled.setFont(System5x7);
          }
          i2cON = 1;  //=1 Störunterdrückung III, i2cON mal keine RC-Auswertung, verhindert Übersprechen nach I2C-Übertragung
        }
      #else  //_MEHRZEILIG

        if( (((int)i/5)==LCDANZPIN && LCDANZPIN<0x100) || (( (1 << ((int)i/5)) & LCDANZPIN) && LCDANZPIN>=0x100  && chanDispAddr[((int)i/5)]) )  // <256: Adresse per LCD anzuzeigenden Rückmeldeabschnitts mit 0 beginnend; >255: bitcodiert die auszuwertenden Kanäle, z. B. 0x1FF für alle, 0x104 für 2 (ab V39, nur OLED MEHRZEILIG)
        {
          oled.changeDisplayAddr(chanDispAddr[((int)i/5)]);
          if(TCAADDR) oled.tcaSelect(TCAADDR, chanDispMultiplex[((int)i/5)]);

          static byte cl[] = {0, 0, 0, 0, 0, 0, 0, 0};
          for(int j = 0;j < 8; j++)
          {
            if( chanDispAddr[j]==chanDispAddr[((int)i/5)])
            {
              if(!cl[j]) { oled.clear(); cl[j] = 1;}  // clear nur beim ersten Durchlauf je Display
              break;
            }
          }
           
          if(chanDispSetX[((int)i/5)]==3)       oled.setFont(ZevvPeep8x16), oled.set2X();  
          //if(chanDispSetX[((int)i/5)]==3)  oled.setFont(ZevvPeep8x16), oled.set1X();  
          else if(chanDispSetX[((int)i/5)]==2)  oled.setFont(font5x7),  oled.set2X();
          else                                  oled.setFont(font5x7),  oled.set1X();
          
          if( i%5==0 ) 
          {
            oled.setCursor(0, chanDispYPos[((int)i/5)]);   //col - The column number in pixels; row the row number in eight pixel rows
            oled.print("                                               ");
            oled.setCursor(0, chanDispYPos[((int)i/5)]);   //col - The column number in pixels; row the row number in eight pixel rows
            #ifdef SHOWCHAN
              if((SHOWCHAN+7>=10)&&(SHOWCHAN+i/5<10))     oled.print(" ");
              if((SHOWCHAN+7>=100)&&(SHOWCHAN+i/5<100))   oled.print(" ");
              if((SHOWCHAN+7>=1000)&&(SHOWCHAN+i/5<1000)) oled.print(" ");
              oled.print(((int)i/5)+((int)SHOWCHAN) );
              oled.print(":");
            #endif
          }

          if((chanDispUmbruch[((int)i/5)]==2 && i%5==2 )||(chanDispUmbruch[((int)i/5)]==1 && i%5==1 )||(chanDispUmbruch[((int)i/5)]==3 && i%5==3 )||(chanDispUmbruch[((int)i/5)]==123 && i%5==1)||(chanDispUmbruch[((int)i/5)]==12 && i%5==1) )
          {
            oled.setCursor(0, chanDispYPos[((int)i/5)] + chanDispSetX[((int)i/5)] );   //col - The column number in pixels; row the row number in eight pixel rows
            oled.print("                                               ");
            oled.setCursor(0, chanDispYPos[((int)i/5)] + chanDispSetX[((int)i/5)] );   //col - The column number in pixels; row the row number in eight pixel rows
            #ifdef SHOWCHAN
              oled.print("  ");
              if(SHOWCHAN+7>=10)   oled.print(" ");
              if(SHOWCHAN+7>=100)  oled.print(" ");
              if(SHOWCHAN+7>=1000) oled.print(" ");
            #endif
          }
          if((chanDispUmbruch[((int)i/5)]==12 && i%5==2 )||(chanDispUmbruch[((int)i/5)]==123 && i%5==2) )
          {
            oled.setCursor(0, chanDispYPos[((int)i/5)]+2*chanDispSetX[((int)i/5)] );   //col - The column number in pixels; row the row number in eight pixel rows
            oled.print("                                               ");
            oled.setCursor(0, chanDispYPos[((int)i/5)]+2*chanDispSetX[((int)i/5)] );   //col - The column number in pixels; row the row number in eight pixel rows
            #ifdef SHOWCHAN
              oled.print("  ");
              if(SHOWCHAN+7>=10)   oled.print(" ");
              if(SHOWCHAN+7>=100)  oled.print(" ");
              if(SHOWCHAN+7>=1000) oled.print(" ");
            #endif
          }
          if((chanDispUmbruch[((int)i/5)]==123 && i%5==3 )) 
          {
            oled.setCursor(0, chanDispYPos[((int)i/5)]+3*chanDispSetX[((int)i/5)] );   //col - The column number in pixels; row the row number in eight pixel rows
            oled.print("                                               ");
            oled.setCursor(0, chanDispYPos[((int)i/5)]+3*chanDispSetX[((int)i/5)] );   //col - The column number in pixels; row the row number in eight pixel rows
            #ifdef SHOWCHAN
              oled.print("  ");
              if(SHOWCHAN+7>=10)   oled.print(" ");
              if(SHOWCHAN+7>=100)  oled.print(" ");
              if(SHOWCHAN+7>=1000) oled.print(" ");
            #endif
          }
          
          if (LokRCaddr[i]) {
            buffer[0] = buffer[1] = LokRCdir[i];
            buffer[2] = buffer[3] = buffer[4] = buffer[5] = buffer[6] = ' ';
            itoa(LokRCaddr[i], &buffer[2], 10);      // 106 Byte
            buffer[strlen(buffer)] = ' ';
            buffer[7] = 0;
            buffer[2+NRSTELLEN] = 0;
            oled.print(buffer);
            //oled.set1X();
          }
          i2cON = 1;  //=1 Störunterdrückung III, i2cON mal keine RC-Auswertung, verhindert Übersprechen nach I2C-Übertragung
  
        }
      #endif
    #endif
    #ifdef LCD  
      if( ((LCDANZPIN * 5)<=i) && (i<(LCDANZPIN * 5 + 4)) )
      {
        lcd.setCursor(posX[i%5], posY[i%5]);     //  10 Byte
        if (LokRCaddr[i]) {
          buffer[0] = buffer[1] = LokRCdir[i];
          itoa(LokRCaddr[i], &buffer[2], 10);      // 106 Byte
          buffer[strlen(buffer) + 3] = ' ';
          buffer[strlen(buffer) + 2] = ' ';
          buffer[strlen(buffer) + 1] = ' ';
          buffer[strlen(buffer)] = ' ';
          lcd.print(buffer);       //  40 Byte
        }
        else {
          lcd.print("        ");
        }
        i2cON = 1;  //=1 Störunterdrückung III, i2cON mal keine RC-Auswertung, verhindert Übersprechen nach I2C-Übertragung
      }
    #endif
#endif
    }
#ifdef LCD2SERIAL
  if (boChange) Serial.println("");
#endif


#if defined(ANDREAS)

  short abzweigLok[70] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70};
  byte b = 0;

  for (int i = 0; i < 21; i++) {
    if (abzweigLok[i] == LokRCaddr[0] || abzweigLok[i] == LokRCaddr[1] || abzweigLok[i] == LokRCaddr[2] || abzweigLok[i] == LokRCaddr[3]) b |= 1;
  }
  short geradeLok[60] = {71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120};
  for (int i = 0; i < 21; i++) {
    //      if(geradeLok[i]==LokRCaddr[0]) b=2;
    if (geradeLok[i] == LokRCaddr[0] || geradeLok[i] == LokRCaddr[1] || geradeLok[i] == LokRCaddr[2] || geradeLok[i] == LokRCaddr[3]) b |= 2;
  }
  if (b & 1) digitalWrite(3, 1);
  else     digitalWrite(3, 0);
  if (b & 2) digitalWrite(4, 1);
  else     digitalWrite(4, 0);
#endif

#ifdef PINDEBUG
  digitalWrite(3, 0);
  //  digitalWrite(1, (v>(350)) );
#if defined(__AVR_ATmega328P__)  // NANO
  digitalWrite(4, 0);
#endif
#endif

#endif



  // #### ab hier Code zur einfachen Besetztmeldung eingefügt, detektiere Strom über den Dioden
#if defined(__AVR_ATmega328P__)  // NANO
  delay(1);  //sicher aus RC-Cutout raus

  static short belegtX[8] = {0, 0, 0, 0, 0, 0, 0, 0};
  static int v;
  belegtOld = belegt;
  for (int i = 0; i < BLOCKANZ; i++) {
    v = analogRead(i + ANALOGREADPIN);
    for (int j = 0; j < 3; j++) {
      v = analogRead(i + ANALOGREADPIN);
      if ((v < (ux0[i] - 30 - noschottky[i])) || (v > (ux0[i] + 30 + noschottky[i]))) {
        if (belegtX[i] > 100) belegtX[i] = min(belegtX[i] + 10, 2 * 100); // 500 ist ca. 1 s
        belegtX[i] = min(belegtX[i] + 1,  2 * 100);                       // 500 ist ca. 1 s
      }
      else belegtX[i] = max(belegtX[i] - 1, 1);
    }

    if ((belegtX[i] > 80) && !(belegtOld & 1 << i)) searchChan = i, searchChanFix = 3; //neue Belegung, lese zuerst diesen Abschnitt 3x (bewusstes fixieren eines Kanals für eine bestimmte Anzahl Durchlaeufe)

// erfolgloser Test 2019-09-26: auch wenn Gleis frei wird
//    if ((belegtX[i] < 20) && !(belegtOld &= ~(1 << i))) searchChan = i, searchChanFix = 3; //neue Belegung, lese zuerst diesen Abschnitt 3x (bewusstes fixieren eines Kanals für eine bestimmte Anzahl Durchlaeufe)

    if (belegtX[i] > 80) belegt |= 1 << i; //setze Bit
    if (belegtX[i] < 20) belegt &= ~(1 << i); //loesche Bit
  }

  //Debugausgabe
#ifdef LCD2SERIAL
  if (belegt != belegtOld) {
    Serial.print("||: ");
    for (int i = 0; i < BLOCKANZ; i++) {
      Serial.print((belegt & (1 << i)) != 0);
    }
    Serial.println("");
  }
#endif
#if defined(LOCONET)
  for (int i = 0; i < BLOCKANZ; i++) {
    lnMsg SendPacket ;

    if(belegtInitDelay<250) belegtInitDelay++;

    if ( ((belegtOld & (1 << i)) !=  (belegt & (1 << i)))            //Belegung geaendert ?
       ||((belegtInit & (1 << i)) != 0)&&(belegtInitDelay>=250)  ) { //aktueller Zustand noch nicht gemeldet 2019-12-22
      belegtInit = belegtInit & ~(1 << i);
      
      SendPacket.data[ 0 ] = 0xB2 ;
      SendPacket.data[ 1 ] = (((i*INVERTBLOCKADDR + FIRSTBLOCKADDR - 1) / 2) & 0x1F) ; //LN Sensor/2   =0x00 = 2, 0x01 = 4, 0x02 = 6, 0x03 = 8
      SendPacket.data[ 2 ] = 0x40 + (0x10 * ((belegt & (1 << i)) != 0)) + 0x20 * ((i*INVERTBLOCKADDR + FIRSTBLOCKADDR - 1) % 2); //LN Sensor + on/off + "Adresse+1"
      //LocoNet.send( &SendPacket ) ;  //checksum wird automatisch berechnet
      LocoNet_sendX( &SendPacket ) ;  //checksum wird automatisch berechnet
    }
  }
#endif
#endif  //NANO



#ifdef WENDE
// Wendeschleifenfunktion, Ansteuerung eines BISTABILEN Relais mit HIGH-Signal auf zwei Pins, wenn eine Lok aus einem oder anderem Abschnitt detektiert wird (Muster)
// -------->|--0-->|<--1-->|<-------2------->|<--3-->|<--5--|<--------
// Abschnitt 0 und 1 sowie 3 und 5! lösen einen Umschaltimpuls aus, Abschnitt 1,2,3 werden umgepolt

  if(isAbschnittBelegt(0)||isAbschnittBelegt(1) ) {
    digitalWrite(3, 1);
    digitalWrite(4, 0);
  }
  else if(isAbschnittBelegt(3)||isAbschnittBelegt(5) ) {
    digitalWrite(3, 0);
    digitalWrite(4, 1);
  }
#endif



#ifdef MIRKO   
// Ansteuerung von Zubehör via LocoNet in Abhängigkeit der Belegung mit bestimmter Lokaddresse und Blockbelegung eines anderen Abschnittes (Muster)
// gegangenLokRCaddr, gekommenLokRCaddr, aktChan
// Beispiele: 
// if ((gekommenLokRCaddr) && (gekommenLokRCaddr==13) && (aktChan == 0)) {                         // Lok gültig und Lok 13 an Anschnitt 0 (A0) "gekommen"
// if ((gegangenLokRCaddr) && (gegangenLokRCaddr==31) && ((aktChan*INVERTBLOCKADDR + FIRSTBLOCKADDR) == 7)) {  // Lok gültig und Lok 31 in Block 7 "gegangen"

  short aList[] = {200,31,4,3,2,1};
  if(gekommenLokRCaddr&&(aktChan == 0) &&!isAbschnittBelegt(5) ) {

    if(ISINLIST(gekommenLokRCaddr,aList) ) {  //wenn gekommene Lok in Liste aList Weiche 7 in Normalstellung
      setLNTurnout(7, TURNOUT_NORMAL);
    }
    else {                                    
      setLNTurnout(7, TURNOUT_DIVERGING);
    }
  }
#endif

// Test Weichensteuerung über reine Belegtmeldung (nur beim Kommen und Gehen)
#ifdef MIRKO_Test2     
  if(isAbschnittBelegtGekommen(5) ) {
    setLNTurnout(8, TURNOUT_NORMAL);
  }
  if(isAbschnittFreiGegangen(5) ) {
    setLNTurnout(8, TURNOUT_DIVERGING);
  }
#endif

#ifdef MIRKO  //_Test3     
// Ansteuerung von Lokfunktionen via LocoNet OPC_IMM_PACKET, Zustand im Refreshpuffer bleibt unverändert !!! Somit nur für Impulse (Sounds) geeignet.
//   lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
//   lnSendImmPacketToDcc(gekommenLokRCaddr, 0xB0| 0b0000);       // 0b0000 = F8, F7, F6, F5
//   lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0000);       // 0b0000 = F12, F11, F10, F9

//   lnSendImmPacketToDcc(gekommenLokRCaddr, 0xde, 0b00000000);   // 0b00000000 = F20, F19, F18, F17, F16, F15, F14, F13
//   lnSendImmPacketToDcc(gekommenLokRCaddr, 0xdf, 0b00000000);   // 0b00000000 = F28, F27, F26, F25, F24, F23, F22, F21

  short aList_2[] = {1234,31,4,3,2,1,111};
  if(gekommenLokRCaddr&&(aktChan == 0) && ISINLIST(gekommenLokRCaddr,aList_2) )  {  // Lok an Anschnitt 0 (A0) "gekommen" und in Liste setze kurz F3
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00000);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
      lnSendImmPacketToDcc(gekommenLokRCaddr, 0x80| 0b00100);      // 0b00000 = F0, F4, F3, F2, F1
  }
  if(gekommenLokRCaddr&&(aktChan == 0) && (gekommenLokRCaddr == 60) )  {  // Lok an Anschnitt 0 (A0) "gekommen" und in Liste setze kurz F3
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0000);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0000);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0000);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0000);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0000);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0000);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0000);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0000);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0001);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0001);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0001);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0001);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0001);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0001);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0001);       // 0b0000 = F12, F11, F10, F9
    lnSendImmPacketToDcc(gekommenLokRCaddr, 0xA0| 0b0001);       // 0b0000 = F12, F11, F10, F9

  }
#endif

}




ISR(ADC_vect)            //ADC interrupt
{
  werte[werte_i++] = ADC;
}


